import { isNavigationParams, } from "./models/route.js";
export async function checkConditions(conditions, location, pathParams, searchParams) {
    if (!Array.isArray(conditions)) {
        return checkSingleCondition(conditions, location, pathParams, searchParams);
    }
    for (const condition of conditions) {
        const result = checkSingleCondition(condition, location, pathParams, searchParams);
        if ((await result) !== true)
            return result;
    }
    return Promise.resolve(true);
}
function checkSingleCondition(conditions, location, pathParams, searchParams) {
    const conditionResult = conditions({ location, pathParams, searchParams });
    if (typeof conditionResult === "boolean" ||
        isNavigationParams(conditionResult))
        return Promise.resolve(conditionResult);
    return conditionResult;
}
